#ifndef _JFPS_H
#define _JFPS_H

#include <windows.h>

//Fractal rendering info
struct Fractal
{
	//Current State
	int MaxIterations;
	double XMin, XMax, YMin, YMax; //The X/Y axis min/max (boundary) points

	//Julia Fractal Config
	double AddReal, AddImag;
	bool UseC;

	Fractal(int MaxIterations, double XMin, double XMax, double YMin, double YMax, double AddReal, double AddImag, bool UseC) : MaxIterations(MaxIterations), XMin(XMin), XMax(XMax), YMin(YMin), YMax(YMax), AddReal(AddReal), AddImag(AddImag), UseC(UseC) {}
	Fractal() : MaxIterations(200), XMin(-2), XMax(1), YMin(-1), YMax(1), AddReal(0), AddImag(0), UseC(true) {};
};

//Vertex structure
struct Vertex
{
	float x, y, z;
	float u, v;
};

const char* PrepareRenderEngine(HWND hWnd, DWORD Width, DWORD Height, bool IsImmediate=false); //Create the engine objects
void ReleaseRenderEngine(); //Release the engine objects
void DrawFractal(Fractal F, bool DrawToScreen=true); //Runs a fractal render pass
void* GetD3DDevice(); //Returns the IDirect3DDevice9*

#endif