#include "JuliaFractalPixelShader.h"
#include "Settings.h"

//Main execution functions depending on requested type of run
extern const char* ScreenSaverRun(HINSTANCE hInst); //In ScreenSaver.cpp
extern const char* NormalRun(HINSTANCE hInst); //In NormalRun.cpp

//Program entry point
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int nCmdShow)
{
	//Determine the mode to run in
	ParseSettings("JuliaFractalsPixelShaderConfig.cfg");
	const char* ModeSetting=GetSetting("Mode", "Normal");
	bool IsScreenSaverMode=(stricmp(ModeSetting, "ScreenSaver")==0);
	if(pCmdLine && (stricmp(pCmdLine, "ScreenSaver")==0 || stricmp(pCmdLine, "Normal")==0)) //Command line overrides configuration file
		IsScreenSaverMode=((pCmdLine[0]|('a'-'A'))=='s');

	//Execute the main code and then clean up
	const char* MainReturn=(IsScreenSaverMode ? ScreenSaverRun(hInst) : NormalRun(hInst));
	ReleaseRenderEngine();
	ReleaseSettings();
	if(MainReturn)
	{
		MessageBox(NULL, MainReturn, "Error", MB_OK);
		return S_FALSE;
	}

	return S_OK;
}