#ifndef _FPS_H
#define _FPS_H

#include <windows.h>

class FPS
{
	public:
		FPS() { TotalFrames=0; ResetFrames(); LastFpsStringPointer=NULL;} //Constructor
		~FPS() {if(LastFpsStringPointer!=NULL) delete[] LastFpsStringPointer;LastFpsStringPointer=NULL;} //Destructor
		virtual void AddFrame() {FrameOn++;TotalFrames++;} //A new frame has been drawn 
		void ResetFrames() {FrameOn=StoreTicks=OldTicks=LastTotalFrames=0;} //Reset fps system
		DWORD GetTotalFrames() { return TotalFrames; }; //Get the total number of frames the program has drawn
		int GetFpsInt() {return (int)GetFpsFloat();} ////Returns the current average FPS as an integer
		DWORD GetFpsDWORD() {return (DWORD)GetFpsFloat();} //Returns the current average FPS as a unsigned integer
		char* GetFpsString() {return GetFpsString(0);} //Returns the current average FPS as a whole number string
		
		char* GetFpsString(int NumberOfDecimals); //Returns the current average FPS as a string with provided precision
		float GetFpsFloat(); ////Returns the current average FPS as a float
	
	private:
		char *LastFpsStringPointer; //Pointer to the last fps string to clear the memory
		DWORD TotalFrames; //Count of every frame in the engine, used to watch for user pressing or holding keys
		DWORD StoreTicks, OldTicks, FrameOn,LastTotalFrames;
};
#endif